## ulfius 2.1.0

=== src/Makefile ===
#
# Ulfius Framework
#
# Makefile used to build the software
#
# Copyright 2015-2017 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#

LIBORCANIA_LOCATION=../lib/orcania/src
LIBYDER_LOCATION=../lib/yder/src
PREFIX=/usr/local
CC=gcc
CFLAGS=-c -fPIC -Wall -D_REENTRANT -I$(PREFIX)/include -I$(LIBORCANIA_LOCATION) -I$(LIBYDER_LOCATION) $(ADDITIONALFLAGS) $(JANSSONFLAG) $(CURLFLAG) $(WEBSOCKETFLAG)
LIBS=-L$(PREFIX)/lib -L$(LIBORCANIA_LOCATION) -L$(LIBYDER_LOCATION) -lc -lmicrohttpd -lyder -lorcania -lpthread
OUTPUT=libulfius.so
VERSION=2.1

ifneq (($(JANSSONFLAG)),"")
LJANSSON=-ljansson
endif

ifneq (($(CURLFLAG)),"")
LCURL=-lcurl
endif

ifneq (($(WEBSOCKETFLAG)),"")
LWEBSOCKET=-lgnutls
endif

all: release

libulfius.so: ulfius.o u_map.o u_request.o u_response.o u_send_request.o u_websocket.o
	$(CC) -shared -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) ulfius.o u_map.o u_request.o u_response.o u_send_request.o u_websocket.o $(LIBS) $(LJANSSON) $(LCURL) $(LWEBSOCKET)
	ln -sf $(OUTPUT).$(VERSION) $(OUTPUT)

ulfius.o: ulfius.h ulfius.c
	$(CC) $(CFLAGS) ulfius.c

u_map.o: ulfius.h u_map.c
	$(CC) $(CFLAGS) u_map.c

u_request.o: ulfius.h u_request.c
	$(CC) $(CFLAGS) u_request.c

u_response.o: ulfius.h u_response.c
	$(CC) $(CFLAGS) u_response.c

u_websocket.o: ulfius.h u_websocket.c
	$(CC) $(CFLAGS) u_websocket.c

u_send_request.o: ulfius.h u_send_request.c
	$(CC) $(CFLAGS) u_send_request.c

clean:
	rm -f *.o *.so $(OUTPUT) $(OUTPUT).*

install: all
	cp $(OUTPUT).$(VERSION) $(PREFIX)/lib
	cp ulfius.h $(PREFIX)/include
	ldconfig

uninstall:
	rm -f $(PREFIX)/lib/$(OUTPUT)
	rm -f $(PREFIX)/lib/$(OUTPUT).*
	rm -f $(PREFIX)/include/ulfius.h

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libulfius.so

release: ADDITIONALFLAGS=-O3

release: libulfius.so

=== example_programs/simple_example/Makefile ===
#
# Example program
#
# Makefile used to build the software
#
# Copyright 2015-2017 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

LIBYDER_LOCATION=../../lib/yder/src
CC=gcc
CFLAGS=-c -Wall -I$(LIBYDER_LOCATION) -D_REENTRANT $(ADDITIONALFLAGS)
ULFIUS_LOCATION=../../src
LIBS=-L$(LIBYDER_LOCATION) -lc -lulfius -lyder -lorcania -L$(ULFIUS_LOCATION)

all: simple_example

clean:
	rm -f *.o simple_example

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: simple_example

libulfius.so:
	cd $(ULFIUS_LOCATION) && $(MAKE) debug CURLFLAG=-DU_DISABLE_CURL WEBSOCKETFLAG=-DU_DISABLE_WEBSOCKET

simple_example.o: simple_example.c
	$(CC) $(CFLAGS) simple_example.c -DDEBUG -g -O0

simple_example: libulfius.so simple_example.o
	$(CC) -o simple_example simple_example.o $(LIBS)

test: simple_example
	LD_LIBRARY_PATH=$(ULFIUS_LOCATION):${LD_LIBRARY_PATH} ./simple_example

=== example_programs/websocket_example/Makefile ===
#
# Websocket example program
#
# Makefile used to build the software
#
# Copyright 2017 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
CC=gcc
CFLAGS=-c -Wall -I$(ULFIUS_LOCATION) -I$(STATIC_FILE_LOCATION) $(ADDITIONALFLAGS)
ULFIUS_LOCATION=../../src
STATIC_FILE_LOCATION=../../example_callbacks/static_file
LIBS=-lc -lulfius -lyder -lorcania -L$(ULFIUS_LOCATION)

all: websocket_example

clean:
	rm -f *.o websocket_example valgrind.txt

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: websocket_example

libulfius.so:
	cd $(ULFIUS_LOCATION) && $(MAKE) debug JANSSONFLAG=-DU_DISABLE_JANSSON CURLFLAG=-DU_DISABLE_CURL

static_file_callback.o: $(STATIC_FILE_LOCATION)/static_file_callback.c
	$(CC) $(CFLAGS) $(STATIC_FILE_LOCATION)/static_file_callback.c -DDEBUG -g -O0

websocket_example.o: websocket_example.c
	$(CC) $(CFLAGS) websocket_example.c -DDEBUG -g -O0

websocket_example: libulfius.so static_file_callback.o websocket_example.o
	$(CC) -o websocket_example websocket_example.o static_file_callback.o $(LIBS)

test: websocket_example
	LD_LIBRARY_PATH=$(ULFIUS_LOCATION):${LD_LIBRARY_PATH} ./websocket_example

=== debian/changelog ===
ulfius (2.1.0-1) unstable; urgency=medium

  * Initial release

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 25 Jul 2017 19:32:33 +0200

=== debian/control ===
Source: ulfius
Section: devel
Priority: optional
Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper (>= 10)
	, libmicrohttpd-dev
	, libcurl4-gnutls-dev
	, libjansson-dev
	, liborcania-dev
	, libyder-dev
Standards-Version: 4.0.0
Homepage: https://github.com/babelouest/ulfius
#Vcs-Git: https://anonscm.debian.org/collab-maint/oauth2-server.git
#Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/oauth2-server.git

Package: libulfius2.1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Web Framework for REST Applications in C
 Based on GNU Libmicrohttpd for the backend web server, Jansson for the 
 json manipulation library, and Libcurl for the http/smtp client API.
 .
 Used to facilitate creation of web applications in C programs with a 
 small memory footprint, as in embedded systems applications.
 .
 One can create webservices in HTTP or HTTPS mode, stream data, or 
 implement server websockets.

Package: libulfius-dev
Architecture: any
Section: libdevel
Depends: libulfius2.1 (= ${binary:Version})
        , ${misc:Depends}
        , liborcania-dev
        , libyder-dev
Description: Web Framework for REST Applications in - development
 Based on GNU Libmicrohttpd for the backend web server, Jansson for the 
 json manipulation library, and Libcurl for the http/smtp client API.
 .
 Used to facilitate creation of web applications in C programs with a 
 small memory footprint, as in embedded systems applications.
 .
 One can create webservices in HTTP or HTTPS mode, stream data, or 
 implement server websockets.
 .
 This package contains the development files.

## ulfius 2.2.4

=== Makefile ===
#
# Ulfius Framework
#
# Makefile used to build all programs
#
# Copyright 2014-2017 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

LIBULFIUS_LOCATION=./src
LIBORCANIA_LOCATION=lib/orcania/src
LIBYDER_LOCATION=lib/yder/src
EXAMPLES_LOCATION=./example_programs
TESTS_LOCATION=./test

ifeq (($(JANSSONFLAG)),"")
ADD_JANSSONFLAG="JANSSONFLAG=-DU_DISABLE_JANSSON"
endif

ifeq (($(CURLFLAG)),"")
ADD_CURLFLAG="CURLFLAG=-DU_DISABLE_CURL"
endif

ifeq (($(WEBSOCKETFLAG)),"")
ADD_WEBSOCKETFLAG="WEBSOCKETFLAG=-DU_DISABLE_WEBSOCKET"
endif

all: libulfius.so

debug:
	cd $(LIBULFIUS_LOCATION) && $(MAKE) debug $(ADD_JANSSONFLAG) $(ADD_CURLFLAG) $(ADD_WEBSOCKETFLAG)

clean:
	cd $(LIBORCANIA_LOCATION) && $(MAKE) clean
	cd $(LIBYDER_LOCATION) && $(MAKE) clean
	cd $(LIBULFIUS_LOCATION) && $(MAKE) clean
	cd $(EXAMPLES_LOCATION) && $(MAKE) clean
	cd $(TESTS_LOCATION) && $(MAKE) clean

install:
	cd $(LIBULFIUS_LOCATION) && $(MAKE) install

uninstall:
	cd $(LIBULFIUS_LOCATION) && $(MAKE) uninstall

libulfius.so:
	cd $(LIBULFIUS_LOCATION) && $(MAKE) $(ADD_JANSSONFLAG) $(ADD_CURLFLAG) $(ADD_WEBSOCKETFLAG)

=== src/Makefile ===
--- 
+++ 
@@ -23,20 +23,20 @@
 LIBYDER_LOCATION=../lib/yder/src
 PREFIX=/usr/local
 CC=gcc
-CFLAGS=-c -fPIC -Wall -D_REENTRANT -I$(PREFIX)/include -I$(LIBORCANIA_LOCATION) -I$(LIBYDER_LOCATION) $(ADDITIONALFLAGS) $(JANSSONFLAG) $(CURLFLAG) $(WEBSOCKETFLAG)
+CFLAGS=-c -pedantic -std=gnu99 -fPIC -Wall -D_REENTRANT -I$(PREFIX)/include -I$(LIBORCANIA_LOCATION) -I$(LIBYDER_LOCATION) $(ADDITIONALFLAGS) $(JANSSONFLAG) $(CURLFLAG) $(WEBSOCKETFLAG)
 LIBS=-L$(PREFIX)/lib -L$(LIBORCANIA_LOCATION) -L$(LIBYDER_LOCATION) -lc -lmicrohttpd -lyder -lorcania -lpthread
 OUTPUT=libulfius.so
-VERSION=2.1
+VERSION=2.2.4
 
-ifneq (($(JANSSONFLAG)),"")
+ifndef JANSSONFLAG
 LJANSSON=-ljansson
 endif
 
-ifneq (($(CURLFLAG)),"")
+ifndef CURLFLAG
 LCURL=-lcurl
 endif
 
-ifneq (($(WEBSOCKETFLAG)),"")
+ifndef WEBSOCKETFLAG
 LWEBSOCKET=-lgnutls
 endif
 
@@ -46,34 +46,41 @@
 	$(CC) -shared -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) ulfius.o u_map.o u_request.o u_response.o u_send_request.o u_websocket.o $(LIBS) $(LJANSSON) $(LCURL) $(LWEBSOCKET)
 	ln -sf $(OUTPUT).$(VERSION) $(OUTPUT)
 
-ulfius.o: ulfius.h ulfius.c
+libulfius.a: ulfius.o u_map.o u_request.o u_response.o u_send_request.o u_websocket.o
+	ar rcs libulfius.a ulfius.o u_map.o u_request.o u_response.o u_send_request.o u_websocket.o
+
+ulfius.o: ulfius.h u_private.h ulfius.c
 	$(CC) $(CFLAGS) ulfius.c
 
-u_map.o: ulfius.h u_map.c
+u_map.o: ulfius.h u_private.h u_map.c
 	$(CC) $(CFLAGS) u_map.c
 
-u_request.o: ulfius.h u_request.c
+u_request.o: ulfius.h u_private.h u_request.c
 	$(CC) $(CFLAGS) u_request.c
 
-u_response.o: ulfius.h u_response.c
+u_response.o: ulfius.h u_private.h u_response.c
 	$(CC) $(CFLAGS) u_response.c
 
-u_websocket.o: ulfius.h u_websocket.c
+u_websocket.o: ulfius.h u_private.h u_websocket.c
 	$(CC) $(CFLAGS) u_websocket.c
 
-u_send_request.o: ulfius.h u_send_request.c
+u_send_request.o: ulfius.h u_private.h u_send_request.c
 	$(CC) $(CFLAGS) u_send_request.c
 
 clean:
-	rm -f *.o *.so $(OUTPUT) $(OUTPUT).*
+	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).*
 
 install: all
 	cp $(OUTPUT).$(VERSION) $(PREFIX)/lib
 	cp ulfius.h $(PREFIX)/include
-	ldconfig
+	-ldconfig
+
+static-install: static
+	cp libulfius.a $(PREFIX)/lib
+	cp ulfius.h $(PREFIX)/include
 
 uninstall:
-	rm -f $(PREFIX)/lib/$(OUTPUT)
+	rm -f $(PREFIX)/lib/$(OUTPUT) libulfius.a
 	rm -f $(PREFIX)/lib/$(OUTPUT).*
 	rm -f $(PREFIX)/include/ulfius.h
 
@@ -84,3 +91,11 @@
 release: ADDITIONALFLAGS=-O3
 
 release: libulfius.so
+
+static: ADDITIONALFLAGS=-O3
+
+static: libulfius.a
+
+static-debug: ADDITIONALFLAGS=-DDEBUG -g -O0
+
+static-debug: libulfius.a

=== test/Makefile ===
#
# Ulfius library
#
# Makefile used to build the tests
#
# Copyright 2017 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU GENERAL PUBLIC LICENSE
# License as published by the Free Software Foundation;
# version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

CC=gcc
CFLAGS=-Wall -D_REENTRANT -DDEBUG -g -O0
ULFIUS_LOCATION=../src
LIBS=-lc -lorcania -lyder -lulfius -lcheck -lpthread -lm -lrt -lsubunit -L$(ULFIUS_LOCATION)

all: test

clean:
	rm -f *.o u_map core framework valgrind.txt

libulfius.so:
	cd $(ULFIUS_LOCATION) && $(MAKE) debug

u_map: u_map.c
	$(CC) $(CFLAGS) u_map.c -o u_map $(LIBS)

test_u_map: libulfius.so u_map
	-LD_LIBRARY_PATH=$(ULFIUS_LOCATION):${LD_LIBRARY_PATH} ./u_map

core: core.c
	$(CC) $(CFLAGS) core.c -o core $(LIBS)

test_core: libulfius.so core
	-LD_LIBRARY_PATH=$(ULFIUS_LOCATION):${LD_LIBRARY_PATH} ./core

framework: framework.c
	$(CC) $(CFLAGS) framework.c -o framework $(LIBS)

test_framework: libulfius.so framework
	-LD_LIBRARY_PATH=$(ULFIUS_LOCATION):${LD_LIBRARY_PATH} ./framework

test: test_u_map test_core test_framework

=== example_programs/auth_example/Makefile ===
#
# Example program
#
# Makefile used to build the software
#
# Copyright 2015-2017 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
CC=gcc
CFLAGS=-c -Wall -D_REENTRANT $(ADDITIONALFLAGS)
ULFIUS_LOCATION=../../src
LIBS=-lc -lulfius -lyder -lorcania -L$(ULFIUS_LOCATION)

all: auth_client auth_server

clean:
	rm -f *.o auth_client auth_server

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: auth_client auth_server

libulfius.so:
	cd $(ULFIUS_LOCATION) && $(MAKE) debug JANSSONFLAG=-DU_DISABLE_JANSSON WEBSOCKETFLAG=-DU_DISABLE_WEBSOCKET

auth_client.o: auth_client.c libulfius.so
	$(CC) $(CFLAGS) auth_client.c -DDEBUG -g -O0

auth_client: auth_client.o
	$(CC) -o auth_client auth_client.o $(LIBS)

test_auth_client: auth_client
	LD_LIBRARY_PATH=$(ULFIUS_LOCATION):${LD_LIBRARY_PATH} ./auth_client

auth_server.o: auth_server.c libulfius.so
	$(CC) $(CFLAGS) auth_server.c -DDEBUG -g -O0

auth_server: auth_server.o
	$(CC) -o auth_server auth_server.o $(LIBS)

test_auth_server: auth_server
	LD_LIBRARY_PATH=$(ULFIUS_LOCATION):${LD_LIBRARY_PATH} ./auth_server

=== example_programs/injection_example/Makefile ===
#
# injection_example program
#
# Makefile used to build the software
#
# Copyright 2016-2017 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
CC=gcc
CFLAGS=-c -Wall -D_REENTRANT $(ADDITIONALFLAGS)
ULFIUS_LOCATION=../../src
LIBS=-lc -lulfius -lyder -ljansson -L$(ULFIUS_LOCATION)

all: injection_example

clean:
	rm -f *.o injection_example

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: injection_example

libulfius.so:
	cd $(ULFIUS_LOCATION) && $(MAKE) debug JANSSONFLAG=-DU_DISABLE_JANSSON CURLFLAG=-DU_DISABLE_CURL WEBSOCKETFLAG=-DU_DISABLE_WEBSOCKET

injection_example.o: injection_example.c
	$(CC) $(CFLAGS) injection_example.c -DDEBUG -g -O0

injection_example: libulfius.so injection_example.o
	$(CC) -o injection_example injection_example.o $(LIBS)

test: injection_example
	LD_LIBRARY_PATH=$(ULFIUS_LOCATION):${LD_LIBRARY_PATH} ./injection_example

=== example_programs/multiple_callbacks_example/Makefile ===
#
# Example program
#
# Makefile used to build the software
#
# Copyright 2017 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

LIBYDER_LOCATION=../../lib/yder/src
CC=gcc
CFLAGS=-c -Wall -I$(LIBYDER_LOCATION) -D_REENTRANT $(ADDITIONALFLAGS)
ULFIUS_LOCATION=../../src
LIBS=-L$(LIBYDER_LOCATION) -lc -lulfius -lyder -lorcania -L$(ULFIUS_LOCATION)

all: multiple_callbacks_example

clean:
	rm -f *.o multiple_callbacks_example valgrind.txt

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: multiple_callbacks_example

libulfius.so:
	cd $(ULFIUS_LOCATION) && $(MAKE) debug JANSSONFLAG=-DU_DISABLE_JANSSON CURLFLAG=-DU_DISABLE_CURL WEBSOCKETFLAG=-DU_DISABLE_WEBSOCKET

multiple_callbacks_example.o: multiple_callbacks_example.c
	$(CC) $(CFLAGS) multiple_callbacks_example.c -DDEBUG -g -O0

multiple_callbacks_example: libulfius.so multiple_callbacks_example.o
	$(CC) -o multiple_callbacks_example multiple_callbacks_example.o $(LIBS)

test: multiple_callbacks_example
	LD_LIBRARY_PATH=$(ULFIUS_LOCATION):${LD_LIBRARY_PATH} ./multiple_callbacks_example

=== example_programs/proxy_example/Makefile ===
#
# Example program
#
# Makefile used to build the software
#
# Copyright 2015-2017 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
CC=gcc
CFLAGS=-c -Wall -D_REENTRANT $(ADDITIONALFLAGS)
ULFIUS_LOCATION=../../src
LIBS=-lc -lorcania -lulfius -ljansson -lyder -L$(ULFIUS_LOCATION)

all: proxy

clean:
	rm -f *.o proxy

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: proxy

libulfius.so:
	cd $(ULFIUS_LOCATION) && $(MAKE) debug JANSSONFLAG=-DU_DISABLE_JANSSON WEBSOCKETFLAG=-DU_DISABLE_WEBSOCKET

proxy.o: proxy.c
	$(CC) $(CFLAGS) proxy.c -DDEBUG -g -O0

proxy: libulfius.so proxy.o
	$(CC) -o proxy proxy.o $(LIBS)

test: proxy
	LD_LIBRARY_PATH=$(ULFIUS_LOCATION):${LD_LIBRARY_PATH} ./proxy

=== example_programs/request_example/Makefile ===
#
# Example program
#
# Makefile used to build the software
#
# Copyright 2015-2017 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
CC=gcc
CFLAGS=-c -Wall -D_REENTRANT $(ADDITIONALFLAGS) -I$(ULFIUS_LOCATION)
ULFIUS_LOCATION=../../src
LIBS=-lc -ljansson -lyder -lorcania -lulfius -L$(ULFIUS_LOCATION)

all: client server mail

clean:
	rm -f *.o client server mail

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: client server mail

libulfius.so:
	cd $(ULFIUS_LOCATION) && $(MAKE) debug WEBSOCKETFLAG=-DU_DISABLE_WEBSOCKET

client.o: client.c libulfius.so
	$(CC) $(CFLAGS) client.c -DDEBUG -g -O0

client: client.o
	$(CC) -o client client.o $(LIBS)

server.o: server.c libulfius.so
	$(CC) $(CFLAGS) server.c -DDEBUG -g -O0

server: server.o
	$(CC) -o server server.o $(LIBS)

mail.o: mail.c libulfius.so
	$(CC) $(CFLAGS) mail.c -DDEBUG -g -O0

mail: mail.o
	$(CC) -o mail mail.o $(LIBS)

=== example_programs/sheep_counter/Makefile ===
#
# Sheep counter program
#
# Makefile used to build the software
#
# Copyright 2015-2017 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
CC=gcc
CFLAGS=-c -Wall -D_REENTRANT $(ADDITIONALFLAGS)
ULFIUS_LOCATION=../../src
LIBS=-lc -lulfius -lyder -lorcania -ljansson -L$(ULFIUS_LOCATION)

all: sheep_counter

clean:
	rm -f *.o sheep_counter

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: sheep_counter

libulfius.so:
	cd $(ULFIUS_LOCATION) && $(MAKE) debug CURLFLAG=-DU_DISABLE_CURL WEBSOCKETFLAG=-DU_DISABLE_WEBSOCKET

sheep_counter.o: sheep_counter.c
	$(CC) $(CFLAGS) sheep_counter.c -DDEBUG -g -O0

sheep_counter: libulfius.so sheep_counter.o
	$(CC) -o sheep_counter sheep_counter.o $(LIBS)

test: sheep_counter
	LD_LIBRARY_PATH=$(ULFIUS_LOCATION):${LD_LIBRARY_PATH} ./sheep_counter

=== example_programs/simple_example/Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 #
-
+PREFIX=/usr/local
 LIBYDER_LOCATION=../../lib/yder/src
 CC=gcc
 CFLAGS=-c -Wall -I$(LIBYDER_LOCATION) -D_REENTRANT $(ADDITIONALFLAGS)
@@ -39,3 +39,6 @@
 
 test: simple_example
 	LD_LIBRARY_PATH=$(ULFIUS_LOCATION):${LD_LIBRARY_PATH} ./simple_example
+
+static: simple_example.o
+	$(CC) -o simple_example simple_example.o $(PREFIX)/lib/liborcania.a $(PREFIX)/lib/libyder.a $(PREFIX)/lib/libulfius.a -ljansson -lmicrohttpd -lpthread -lgnutls

=== example_programs/stream_example/Makefile ===
#
# Example program
#
# Makefile used to build the software
#
# Copyright 2016 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
CC=gcc
CFLAGS=-c -Wall -D_REENTRANT $(ADDITIONALFLAGS)
ULFIUS_LOCATION=../../src
LIBS=-lc -lorcania -lulfius -lyder -L$(ULFIUS_LOCATION)

all: stream_example stream_client

clean:
	rm -f *.o stream_example stream_client

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: stream_example stream_client

libulfius.so:
	cd $(ULFIUS_LOCATION) && $(MAKE) debug JANSSONFLAG=-DU_DISABLE_JANSSON WEBSOCKETFLAG=-DU_DISABLE_WEBSOCKET

stream_example.o: stream_example.c
	$(CC) $(CFLAGS) stream_example.c -DDEBUG -g -O0

stream_example: libulfius.so stream_example.o
	$(CC) -o stream_example stream_example.o $(LIBS)

stream_client.o: stream_client.c
	$(CC) $(CFLAGS) stream_client.c -DDEBUG -g -O0

stream_client: libulfius.so stream_client.o
	$(CC) -o stream_client stream_client.o $(LIBS)

test: stream_example stream_client
	LD_LIBRARY_PATH=$(ULFIUS_LOCATION):${LD_LIBRARY_PATH} ./stream_example

=== example_programs/test_u_map/Makefile ===
#
# Example program
#
# Makefile used to build the software
#
# Copyright 2014-2015 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
CC=gcc
CFLAGS=-c -Wall -D_REENTRANT $(ADDITIONALFLAGS)
ULFIUS_LOCATION=../../src
LIBS=-lc -lorcania -lulfius -lyder -L$(ULFIUS_LOCATION)

all: test_u_map

clean:
	rm -f *.o test_u_map

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: test_u_map

libulfius.so:
	cd $(ULFIUS_LOCATION) && $(MAKE) debug JANSSONFLAG=-DU_DISABLE_JANSSON CURLFLAG=-DU_DISABLE_CURL WEBSOCKETFLAG=-DU_DISABLE_WEBSOCKET

test_u_map.o: test_u_map.c
	$(CC) $(CFLAGS) test_u_map.c -DDEBUG -g -O0

test_u_map: libulfius.so test_u_map.o
	$(CC) -o test_u_map test_u_map.o $(LIBS)

test: test_u_map
	LD_LIBRARY_PATH=$(ULFIUS_LOCATION):${LD_LIBRARY_PATH} ./test_u_map

=== debian/changelog ===
ulfius (2.2.4-1) unstable; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.1.3 (no changes)
  * debian/control: use dh11

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 26 Jan 2018 14:54:14 +0100

ulfius (2.2-1) unstable; urgency=medium

  * New upstream release
  * debian/control: bump standard, no changes
  * debian/control: handle SONAME bump

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 21 Nov 2017 18:56:19 +0100

ulfius (2.1.2-1) unstable; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.1.0 (no changes)
  * debian/control: add VCS URLs
  * debian/control: set team as maintainer

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 03 Sep 2017 19:06:24 +0200

=== debian/control ===
Source: ulfius
Section: devel
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper (>= 11)
	, libmicrohttpd-dev
	, libcurl4-gnutls-dev
	, libjansson-dev
	, liborcania-dev
	, libyder-dev
Standards-Version: 4.1.3
Homepage: https://github.com/babelouest/ulfius
Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/ulfius.git
Vcs-Git: https://anonscm.debian.org/git/debian-iot/ulfius.git

Package: libulfius2.2
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Web Framework for REST Applications in C
 Based on GNU Libmicrohttpd for the backend web server, Jansson for the
 json manipulation library, and Libcurl for the http/smtp client API.
 .
 Used to facilitate creation of web applications in C programs with a
 small memory footprint, as in embedded systems applications.
 .
 One can create webservices in HTTP or HTTPS mode, stream data, or
 implement server websockets.

Package: libulfius-dev
Architecture: any
Section: libdevel
Depends: libulfius2.2 (= ${binary:Version})
        , ${misc:Depends}
        , liborcania-dev
        , libyder-dev
Description: Web Framework for REST Applications in - development
 Based on GNU Libmicrohttpd for the backend web server, Jansson for the
 json manipulation library, and Libcurl for the http/smtp client API.
 .
 Used to facilitate creation of web applications in C programs with a
 small memory footprint, as in embedded systems applications.
 .
 One can create webservices in HTTP or HTTPS mode, stream data, or
 implement server websockets.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

override_dh_auto_install:
	echo dh_auto_install

=== debian/watch ===
version=4

# https://github.com/babelouest/ulfius
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ulfius-$1.tar.gz%" \
   https://github.com/babelouest/ulfius/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## ulfius 2.3.7

=== CMakeLists.txt ===
#
# Ulfius library
#
# CMake file used to build all programs
#
# Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
# Copyright 2018 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(ulfius C)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")

# library info

set(PROJECT_DESCRIPTION "HTTP Framework for REST API in C, using JSON or not, with websockets or not, with streaming data or not")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/ulfius/issues")

set(LIBRARY_VERSION_MAJOR "2")
set(LIBRARY_VERSION_MINOR "3")
set(LIBRARY_VERSION_PATCH "7")
set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
set(YDER_VERSION_DOWNLOAD "1.3.3")

# cmake modules

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)

include(GNUInstallDirs)
include(CheckSymbolExists)

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
    check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

    if (NOT _GNU_SOURCE)
        unset(_GNU_SOURCE CACHE)
        check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
    endif ()
endif ()

if (_GNU_SOURCE)
    add_definitions(-D_GNU_SOURCE)
endif ()

# directories and source

set(INC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)

include_directories(${INC_DIR})

set(LIB_SRC
        ${INC_DIR}/ulfius.h
        ${INC_DIR}/u_private.h
        ${SRC_DIR}/u_map.c
        ${SRC_DIR}/u_request.c
        ${SRC_DIR}/u_response.c
        ${SRC_DIR}/u_send_request.c
        ${SRC_DIR}/u_websocket.c
        ${SRC_DIR}/ulfius.c)

# websocket support

option(WITH_WEBSOCKET "Websocket support" ON)

if (WIN32)
	set(WITH_WEBSOCKET OFF)
endif ()

if (NOT WITH_WEBSOCKET)
	add_definitions(-DU_DISABLE_WEBSOCKET)
  set(MHD_MIN_VERSION 0.9.51)
else ()
  set(MHD_MIN_VERSION 0.9.53)
	include(FindGnuTLS)
	find_package(GnuTLS REQUIRED)
	if (GNUTLS_FOUND)
			set(LIBS ${LIBS} ${GNUTLS_LIBRARIES})
	endif ()
endif ()

include(FindMHD)
find_package(MHD ${MHD_MIN_VERSION} REQUIRED)
if (MHD_FOUND)
		set(LIBS ${LIBS} ${MHD_LIBRARIES})
    if (MHD_VERSION_STRING VERSION_LESS "0.9.53")
      set(WITH_WEBSOCKET OFF)
    endif ()
endif ()

option(WITH_CURL "Use Curl library" ON)

if (WITH_CURL)
	include(FindCURL)
	find_package(CURL REQUIRED)
	if (CURL_FOUND)
			set(LIBS ${LIBS} ${CURL_LIBRARIES})
	endif ()
else ()
    add_definitions(-DU_DISABLE_CURL)
endif ()

option(WITH_JANSSON "Use jansson library" ON)

if (WITH_JANSSON)
    include(FindJansson)
		set(JANSSON_MIN_VERSION 2.4)
    find_package(Jansson ${JANSSON_MIN_VERSION} REQUIRED)
    if (JANSSON_FOUND)
        set(LIBS ${LIBS} ${JANSSON_LIBRARIES})
    endif ()
else ()
    add_definitions(-DU_DISABLE_JANSSON)
endif ()

# static library

option(BUILD_STATIC "Build static library." OFF)

if (BUILD_STATIC)
	add_library(ulfius_static STATIC ${LIB_SRC})
	target_compile_definitions(ulfius_static PUBLIC -DO_STATIC_LIBRARY)
	set_target_properties(ulfius_static PROPERTIES
					OUTPUT_NAME libulfius)
endif ()

# shared library

add_library(ulfius SHARED ${LIB_SRC})
set_target_properties(ulfius PROPERTIES
        COMPILE_OPTIONS -Wextra
        PUBLIC_HEADER ${INC_DIR}/ulfius.h
        VERSION "${LIBRARY_VERSION}"
        SOVERSION "${LIBRARY_SOVERSION}")
if (WIN32)
    set_target_properties(ulfius PROPERTIES SUFFIX "-${LIBRARY_VERSION_MAJOR}.dll")
endif ()
target_link_libraries(ulfius ${LIBS})

# dependencies

option(CHECK_YDER "Check Yder library." ON)

if (CHECK_YDER)
  set(Yder_FIND_QUIETLY ON) # force to find Yder quietly
  include(FindYder)
  find_package(Yder 1.1 QUIET) # try to find Yder
  if (NOT YDER_FOUND)
      include(DownloadProject)
      download_project(PROJ yder # ... otherwise, download archive
              URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_DOWNLOAD}.tar.gz"
              QUIET)
      add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
      include_directories(${yder_SOURCE_DIR}/include)
      include_directories(${orcania_SOURCE_DIR}/include)
      add_dependencies(ulfius yder)
      add_dependencies(ulfius orcania)
      set(YDER_LIBRARIES yder orcania)
  endif ()

  target_link_libraries(ulfius ${LIBS} ${YDER_LIBRARIES})
endif()

# tests

option(BUILD_TESTING "Build the testing tree." OFF) # because we do not use include(CTest)

if (BUILD_TESTING)
    include(FindCheck)
    find_package(Check REQUIRED)
    if (CHECK_FOUND)
        if (NOT WIN32)
            include(FindSubunit)
            find_package(Subunit REQUIRED)
        endif ()

        enable_testing()

        set(CMAKE_CTEST_COMMAND ctest -V)

        set(TST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
        set(LIBS ulfius ${LIBS} ${CHECK_LIBRARIES})
        if (NOT WIN32)
            find_package(Threads REQUIRED)
            set(LIBS ${LIBS} ${SUBUNIT_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} m rt)
        endif ()

        set(TESTS core u_map framework)

        configure_file(
                "${CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
                "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
                @ONLY)

        foreach (t ${TESTS})
            add_executable(${t} EXCLUDE_FROM_ALL ${TST_DIR}/${t}.c)
            target_include_directories(${t} PUBLIC ${TST_DIR})
            target_link_libraries(${t} PUBLIC ${LIBS})
            add_test(NAME ${t}
                    WORKING_DIRECTORY ${TST_DIR}
                    COMMAND ${t})
        endforeach ()
    endif ()
endif ()

# install target

option(INSTALL_HEADER "Install the header files" ON) # Install ulfius.h or not

configure_file(libulfius.pc.in libulfius.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libulfius.pc
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/pkgconfig)

SET (TARGETS ulfius)
if (BUILD_STATIC)
	SET (TARGETS ${TARGETS} ulfius_static)
endif ()

if (INSTALL_HEADER)
install(TARGETS ${TARGETS}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
    install(DIRECTORY example_callbacks/
            DESTINATION ${CMAKE_INSTALL_DOCDIR}/example_callbacks/ COMPONENT runtime)
    install(DIRECTORY example_programs/
            DESTINATION ${CMAKE_INSTALL_DOCDIR}/example_programs/ COMPONENT runtime)
    install(FILES README.md
            DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT runtime)
    install(FILES INSTALL.md
            DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT runtime)
    install(FILES API.md
            DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT runtime)
else ()
install(TARGETS ${TARGETS}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif ()

# uninstall target

if (NOT TARGET uninstall)
    configure_file(
            "${CMAKE_MODULE_PATH}/CMakeUninstall.cmake.in"
            "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
            IMMEDIATE @ONLY)
    add_custom_target(uninstall
            COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif ()

# packaging

set(CPACK_PACKAGE_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

if (INSTALL_HEADER)
set(PACKAGE_FILE_NAME
        "lib${CMAKE_PROJECT_NAME}-dev_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
else ()
set(PACKAGE_FILE_NAME
        "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
endif ()
set(PACKAGE_IGNORED_FILES
        "${CMAKE_CURRENT_BINARY_DIR}/;/.git/;.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}")

set(CPACK_GENERATOR "TGZ;DEB")
set(CPACK_DEBIAN_PACKAGE_NAME "libulfius")
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "mail@babelouest.org")
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION ${PROJECT_DESCRIPTION})
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "http://babelouest.github.io/ulfius/")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.4), liborcania (>= 1.2), libyder (>= 1.3)")
if (WITH_CURL)
  set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libcurl3-gnutls (>= 7.16.2)")
endif ()
if (WITH_JANSSON)
  set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libjansson4 (>= 2.1)")
endif ()
if (WITH_WEBSOCKET)
  set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libgnutls30 (>= 3.5.0), libmicrohttpd12 (>= 0.9.53)")
else ()
  set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libmicrohttpd12 (>= 0.9.51)")
endif ()
set(CPACK_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})

set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})
set(CPACK_SOURCE_IGNORE_FILES ${PACKAGE_IGNORED_FILES})

include(CPack)

add_custom_target(dist_u
        COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

=== example_programs/CMakeLists.txt ===
#
# Ulfius library
#
# CMake file used to build example programs
#
# Copyright 2018 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(ulfius_examples C)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")

# library info

set(PROJECT_DESCRIPTION "HTTP Framework for REST API in C, using JSON or not, with websockets or not, with streaming data or not")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/ulfius/issues")

include(GNUInstallDirs)
include(CheckSymbolExists)

# cmake modules

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
    check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

    if (NOT _GNU_SOURCE)
        unset(_GNU_SOURCE CACHE)
        check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
    endif ()
endif ()

if (_GNU_SOURCE)
    add_definitions(-D_GNU_SOURCE)
endif ()

include(FindOrcania)
set(ORCANIA_MIN_VERSION "1.1.1")
find_package(Orcania ${ORCANIA_MIN_VERSION} REQUIRED)
set(LIBS ${ORCANIA_LIBRARIES})

include(FindYder)
set(YDER_MIN_VERSION "1.1.1")
find_package(Yder ${YDER_MIN_VERSION} REQUIRED)
set(LIBS ${LIBS} ${YDER_LIBRARIES})

include(FindUlfius)
set(ULFIUS_MIN_VERSION "2.2")
find_package(Ulfius ${ULFIUS_MIN_VERSION} REQUIRED)
set(LIBS ${LIBS} ${ULFIUS_LIBRARIES})

# websocket support

option(WITH_WEBSOCKET "Websocket support" ON)

if (WIN32)
	set(WITH_WEBSOCKET OFF)
endif ()

if (NOT WITH_WEBSOCKET)
	add_definitions(-DU_DISABLE_WEBSOCKET)
  set(MHD_MIN_VERSION 0.9.51)
else ()
  set(MHD_MIN_VERSION 0.9.53)
	include(FindGnuTLS)
	find_package(GnuTLS REQUIRED)
	if (GNUTLS_FOUND)
			set(LIBS ${LIBS} ${GNUTLS_LIBRARIES})
	endif ()
endif ()

include(FindMHD)
find_package(MHD ${MHD_MIN_VERSION} REQUIRED)
if (MHD_FOUND)
		set(LIBS ${LIBS} ${MHD_LIBRARIES})
    if (MHD_VERSION_STRING VERSION_LESS "0.9.53")
      set(WITH_WEBSOCKET OFF)
    endif ()
endif ()

option(WITH_CURL "Use Curl library" ON)

if (WITH_CURL)
	include(FindCURL)
	find_package(CURL REQUIRED)
	if (CURL_FOUND)
			set(LIBS ${LIBS} ${CURL_LIBRARIES})
	endif ()
else ()
    add_definitions(-DU_DISABLE_CURL)
endif ()

option(WITH_JANSSON "Use jansson library" ON)

if (WITH_JANSSON)
    include(FindJansson)
		set(JANSSON_MIN_VERSION 2.4)
    find_package(Jansson ${JANSSON_MIN_VERSION} REQUIRED)
    if (JANSSON_FOUND)
        set(LIBS ${LIBS} ${JANSSON_LIBRARIES})
    endif ()
else ()
    add_definitions(-DU_DISABLE_JANSSON)
endif ()

# examples

set(STATIC_CALLBACK_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../example_callbacks/static_file/)

add_executable(simple_example ${CMAKE_CURRENT_SOURCE_DIR}/simple_example/simple_example.c)
target_link_libraries(simple_example ${LIBS})

add_executable(auth_client ${CMAKE_CURRENT_SOURCE_DIR}/auth_example/auth_client.c)
target_link_libraries(auth_client ${LIBS})

add_executable(auth_server ${CMAKE_CURRENT_SOURCE_DIR}/auth_example/auth_server.c)
target_link_libraries(auth_server ${LIBS})

add_executable(multiple_callbacks_example ${CMAKE_CURRENT_SOURCE_DIR}/multiple_callbacks_example/multiple_callbacks_example.c)
target_link_libraries(multiple_callbacks_example ${LIBS})

add_executable(stream_client ${CMAKE_CURRENT_SOURCE_DIR}/stream_example/stream_client.c)
target_link_libraries(stream_client ${LIBS})

add_executable(stream_example ${CMAKE_CURRENT_SOURCE_DIR}/stream_example/stream_example.c)
target_link_libraries(stream_example ${LIBS})

add_executable(test_u_map ${CMAKE_CURRENT_SOURCE_DIR}/test_u_map/test_u_map.c)
target_link_libraries(test_u_map ${LIBS})

if (WITH_JANSSON)
  add_executable(injection_example ${CMAKE_CURRENT_SOURCE_DIR}/injection_example/injection_example.c)
  target_link_libraries(injection_example ${LIBS})

  add_executable(sheep_counter ${CMAKE_CURRENT_SOURCE_DIR}/sheep_counter/sheep_counter.c)
  target_link_libraries(sheep_counter ${LIBS})
endif ()

if (WITH_CURL AND WITH_JANSSON)
  add_executable(proxy_example ${CMAKE_CURRENT_SOURCE_DIR}/proxy_example/proxy.c)
  target_link_libraries(proxy_example ${LIBS})

  add_executable(request_client ${CMAKE_CURRENT_SOURCE_DIR}/request_example/client.c)
  target_link_libraries(request_client ${LIBS})

  add_executable(request_server ${CMAKE_CURRENT_SOURCE_DIR}/request_example/server.c)
  target_link_libraries(request_server ${LIBS})

  add_executable(request_mail ${CMAKE_CURRENT_SOURCE_DIR}/request_example/mail.c)
  target_link_libraries(request_mail ${LIBS})
endif ()

if (WITH_WEBSOCKET)
  add_executable(websocket_example ${CMAKE_CURRENT_SOURCE_DIR}/websocket_example/websocket_example.c ${STATIC_CALLBACK_DIR}/static_file_callback.c)
  target_link_libraries(websocket_example ${LIBS})
endif ()

=== src/Makefile ===
#
# Ulfius Framework
#
# Makefile used to build the software
#
# Copyright 2015-2018 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#

LIBORCANIA_LOCATION=../lib/orcania/src
LIBYDER_LOCATION=../lib/yder/src
ULFIUS_INCLUDE=../include
DESTDIR=/usr/local
CC=gcc
CFLAGS+=-c -pedantic -std=gnu99 -fPIC -Wall -D_REENTRANT -I$(DESTDIR)/include -I$(ULFIUS_INCLUDE) -I$(LIBORCANIA_LOCATION) -I$(LIBYDER_LOCATION) $(ADDITIONALFLAGS) $(JANSSONFLAG) $(CURLFLAG) $(WEBSOCKETFLAG) $(CPPFLAGS)
LIBS=-L$(DESTDIR)/lib -L$(LIBORCANIA_LOCATION) -L$(LIBYDER_LOCATION) -lc -lmicrohttpd -lyder -lorcania -lpthread $(LDFLAGS)
OUTPUT=libulfius.so
VERSION=2.3.7

ifndef JANSSONFLAG
LJANSSON=-ljansson
endif

ifndef CURLFLAG
LCURL=-lcurl
endif

ifndef WEBSOCKETFLAG
LWEBSOCKET=-lgnutls
endif

all: release

libulfius.so: ulfius.o u_map.o u_request.o u_response.o u_send_request.o u_websocket.o
	$(CC) -shared -fPIC -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) ulfius.o u_map.o u_request.o u_response.o u_send_request.o u_websocket.o $(LIBS) $(LJANSSON) $(LCURL) $(LWEBSOCKET)
	ln -sf $(OUTPUT).$(VERSION) $(OUTPUT)

libulfius.a: ulfius.o u_map.o u_request.o u_response.o u_send_request.o u_websocket.o
	ar rcs libulfius.a ulfius.o u_map.o u_request.o u_response.o u_send_request.o u_websocket.o

ulfius.o: $(ULFIUS_INCLUDE)/ulfius.h $(ULFIUS_INCLUDE)/u_private.h ulfius.c
	$(CC) $(CFLAGS) ulfius.c

u_map.o: $(ULFIUS_INCLUDE)/ulfius.h $(ULFIUS_INCLUDE)/u_private.h u_map.c
	$(CC) $(CFLAGS) u_map.c

u_request.o: $(ULFIUS_INCLUDE)/ulfius.h $(ULFIUS_INCLUDE)/u_private.h u_request.c
	$(CC) $(CFLAGS) u_request.c

u_response.o: $(ULFIUS_INCLUDE)/ulfius.h $(ULFIUS_INCLUDE)/u_private.h u_response.c
	$(CC) $(CFLAGS) u_response.c

u_websocket.o: $(ULFIUS_INCLUDE)/ulfius.h $(ULFIUS_INCLUDE)/u_private.h u_websocket.c
	$(CC) $(CFLAGS) u_websocket.c

u_send_request.o: $(ULFIUS_INCLUDE)/ulfius.h $(ULFIUS_INCLUDE)/u_private.h u_send_request.c
	$(CC) $(CFLAGS) u_send_request.c

clean:
	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).*

install: all
	cp $(OUTPUT).$(VERSION) $(DESTDIR)/lib
	cp $(ULFIUS_INCLUDE)/ulfius.h $(DESTDIR)/include
	-ldconfig

static-install: static
	cp libulfius.a $(DESTDIR)/lib
	cp $(ULFIUS_INCLUDE)/ulfius.h $(DESTDIR)/include

uninstall:
	rm -f $(DESTDIR)/lib/$(OUTPUT) $(DESTDIR)/lib/libulfius.a
	rm -f $(DESTDIR)/lib/$(OUTPUT).*
	rm -f $(DESTDIR)/include/ulfius.h

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libulfius.so

release: ADDITIONALFLAGS=-O3

release: libulfius.so

static: ADDITIONALFLAGS=-O3

static: libulfius.a

static-debug: ADDITIONALFLAGS=-DDEBUG -g -O0

static-debug: libulfius.a

=== debian/changelog ===
ulfius (2.3.7-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 14 Jul 2018 10:24:07 -0400

ulfius (2.3.6-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 16 Jun 2018 07:31:13 -0400

ulfius (2.3.5-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <nicolas@babelouest.org>  Fri, 01 Jun 2018 07:35:12 -0400

ulfius (2.3.4-3) unstable; urgency=medium

  * Fix include ulfius macro in examples

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 28 Apr 2018 14:16:16 -0400

ulfius (2.3.4-2) unstable; urgency=medium

  * Fix quilt-patch-missing-description lintian warning

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 28 Apr 2018 14:02:17 -0400

ulfius (2.3.4-1) unstable; urgency=medium

  * New upstream release
  * Install examples and README.md
  * debian/rules: use cmake as buildsystem
  * debian/copyright: add cmake scripts
  * debian/patches: Adapt examples for debian package

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 28 Apr 2018 09:59:46 -0400

ulfius (2.3.3-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <mail@babelouest.org>  Mon, 02 Apr 2018 09:51:11 -0400

=== debian/control ===
--- 
+++ 
@@ -3,18 +3,20 @@
 Priority: optional
 Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
+          , Nicolas Mora <nicolas@babelouest.org>
 Build-Depends: debhelper (>= 11)
 	, libmicrohttpd-dev
 	, libcurl4-gnutls-dev
 	, libjansson-dev
 	, liborcania-dev
 	, libyder-dev
+  , cmake
 Standards-Version: 4.1.3
 Homepage: https://github.com/babelouest/ulfius
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/ulfius.git
-Vcs-Git: https://anonscm.debian.org/git/debian-iot/ulfius.git
+Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/ulfius.git
+Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/ulfius.git
 
-Package: libulfius2.2
+Package: libulfius2.3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -31,10 +33,11 @@
 Package: libulfius-dev
 Architecture: any
 Section: libdevel
-Depends: libulfius2.2 (= ${binary:Version})
+Depends: libulfius2.3 (= ${binary:Version})
         , ${misc:Depends}
         , liborcania-dev
         , libyder-dev
+        , libjs-jquery
 Description: Web Framework for REST Applications in - development
  Based on GNU Libmicrohttpd for the backend web server, Jansson for the
  json manipulation library, and Libcurl for the http/smtp client API.
